.if *>0
; all working and not really needed to be seen subrotines go here
;--------------------------------------------------
dl .proc 
        :2 .byte $70
        .byte $4f
        .word display

        :100 .by $0f
        .by $0f
        .by $4f
        .wo display+$0ff0
        :89 .byte $0f

        .by $0
        .by $42
        .wo resultLine
        .by 0,$02
        
        ;.by $0
        ;.by $42
        ;.word shapeBuffer
        .byte $41
        .word dl
.endp
resultLine
		dta d"Since game has started you got older by:"
daysDisp
		dta d'00 '
		dta d'days, '
hoursDisp
		dta d'00 '
		dta d'hours, '
minutesDisp
		dta d'00 '
		dta d'mins & '
secondsDisp
		dta d'00 '
		dta d'seconds.'

;--------------------------------------------------
GameInit .local
	cli
	lda #$ff
	sta $d301
	lda #0
	sta hposm0
	sta hposm1
	sta hposm2
	sta hposm3
	sta hposp0	
	sta hposp1	
	sta hposp2	
	sta hposp3
	sta moveSpeed+1

	mwa #clearVariablesStart temp
	ldy #0
loop
	tya
	sta (temp),y
	inw temp
	cpw #clearVariablesEnd temp
	bne loop
	
	mva #screenHeight lowestY ;initially Y is maximal
	
	
	lda #"0"
	sta daysDisp
	sta daysDisp+1
	sta hoursDisp
	sta hoursDisp+1
	sta minutesDisp
	sta minutesDisp+1
	sta secondsDisp
	sta secondsDisp+1
	
	mwa #$0010 fallSpeed ;$0.$20
	mwa #$0030 moveSpeed ;$.40  ;half of move left and right speed. multiply must be equal 1 (e.g. $43 is bad)
	jsr clearscreen
	;jsr smearscreen
	mva #$ff sfx_effect
    ldx #<MODUL					;low byte of RMT module to X reg
    ldy #>MODUL					;hi byte of RMT module to Y reg
    lda #0						;starting song line 0-255 to A reg
    jsr RASTERMUSICTRACKER		;Init

	;keyboard tuning :)
	;thx Rybags: http://atariage.com/forums/topic/192647-turning-off-keyboard-click-in-a-basic-program/
	mva #255 731
	mva #2 729 
	mva #2 730

	
	mwa #dl dlptrs
	jsr spriteBackground
	vmain VBLANK,7
	
	
	rts
.endl
;--------------------------------------------------
VBLANK .local ;vertical blank interrupt
;--------------------------------------------------
	;sfx
	lda sfx_effect
	bmi lab2
	asl @						; * 2
	tay							;Y = 2,4,..,16	instrument number * 2 (0,2,4,..,126)
	ldx #3						;X = 3			channel (0..3 or 0..7 for stereo module)
	lda #12						;A = 12			note (0..60)
	jsr RASTERMUSICTRACKER+15	;RMT_SFX start tone (It works only if FEAT_SFX is enabled !!!)
;
	lda #$ff
	sta sfx_effect				;reinit value
;
lab2
	lda ticksPerSecond
	cmp #60
	bne PALMusic
	; it is NTSC HERE -- slow down the sound
	lda ticks
	and #%00000111
	beq skipSoundFrame
PALMusic
	lda slowMusic
	beq playNow
	lda ticks
	and #%00000011
	beq skipSoundFrame
playNow
	jsr RASTERMUSICTRACKER+3
skipSoundFrame

	;move speed update
	;check fire for slow down
	;if TRIG0==0 OR SKSTAT==$F7 then moveSpeed == normalMoveSpeed*2
	lda TRIG0
	beq faster
	lda SKSTAT
	cmp #$f7 ;- shift
	beq faster
	mva #normalMoveSpeed movespeed ;(lower byte only)
	jmp speedChangeEnd
faster
	mva #normalMoveSpeed*2 movespeed ;(lower byte only)
	
speedChangeEnd

	;time update
	inc:lda ticks
	cmp ticksPerSecond
	jne VBLANKEND
	mva #0 ticks
	inc:lda seconds
	cmp #60
	jne VBLANKEND
	mva #0 seconds
	inc:lda minutes
	cmp #60
	bne VBLANKEND
	mva #0 minutes
	inc:lda hours ;bug found by TDC - thxxx
	cmp #24
	bne VBLANKEND
	mva #0 hours
	inc days
	;if it gets to more than 99 days, game starts to show improper values :) (i.e. last 2 digits)
	
VBLANKEND	
 	jmp XITVBV
.endl

;--------------------------------------------------
WaitForIt .local ;waits for some line down there to minimise flickering
;--------------------------------------------------
	lda VCOUNT
	cmp #120 ;wait for line 120*2. works on ntsc and pal
	bcc WaitForIt
	rts
.endl

;--------------------------------------------------
PrintTimes .local ;displays current spent time
;--------------------------------------------------
	lda seconds
	sta decimal
	jsr displaydec.displaybyte
	mwa decimalresult secondsDisp
	lda minutes
	sta decimal
	jsr displaydec.displaybyte
	mwa decimalresult minutesDisp
	lda hours
	sta decimal
	jsr displaydec.displaybyte
	mwa decimalresult hoursDisp
	lda days
	sta decimal
	jsr displaydec.displaybyte
	mwa decimalresult daysDisp
	
	rts
.endl
;--------------------------------------------------
CheckPALorNTSC .local
;--------------------------------------------------
	lda $d014 ;http://www.myatari.com/nirdary.html
	and #%00001110
	bne NTSC
	lda #50
	sta ticksPerSecond
	rts
NTSC
	lda #60
	sta ticksPerSecond
	rts
.endl
;--------------------------------------------------
RandomizeShape .local
;--------------------------------------------------
		randomize 0 3
		sta currRot+1
		randomize 0 6
		sta currShape
		rts
.endl

;--------------------------------------------------
SavePos .local
;--------------------------------------------------
	mwa xpos xposOld
	mwa ypos yposOld
	rts
.endl

;--------------------------------------------------
RetrievePos .local
;--------------------------------------------------
	mwa xposOld xpos
	mwa yposOld ypos	
	rts
.endl

;--------------------------------------------------
ReadControls .local
;--------------------------------------------------
	jsr getkey.noWait
    cmp #$f
    jeq pressedDown
    ldx #1
    stx fallFlag
	cmp #$6
	beq pressedLeft
    cmp #$7
    jeq pressedRight
    cmp #$e
    jeq pressedUp
    jmp notpressed
    
/*  cmp #$21
    jeq pressedSpace
    cmp #$2c
    jeq pressedTAB
    jmp notpressed
*/
pressedUp
	adw currRot #$10 ;$0.$20 -- in fixed point arithmetics
	lda currRot+1
	and #03
	sta currRot+1
	; check if the new position fits on the screen, if not, move on screen
	jsr getSizeXY
	sta addr1
	lda #0
	sta addr1+1
	adw addr1 xpos
	;in addr1 there is right end of the shape
	cpw addr1 #screenWidth 
	jcc notpressed ; do not shift right if touching the screen
	sbw addr1 #screenWidth
	sbw xpos addr1
	jmp notpressed
	
pressedLeft
	lda xpos+1
	clc
	adc xpos  ;  check if == 0
	jeq notpressed

	sbw xposFraction moveSpeed
	bcs doNotDecHighest
	dec xpos+1
doNotDecHighest

	jmp notpressed

pressedRight
	jsr getSizeXY
	sta addr1
	lda #0
	sta addr1+1
	adw addr1 xpos
	;in temp there is right end of the shape
	cpw addr1 #screenWidth 
	jcs notpressed ; do not shift right if touching the screen

	;shift right here
	adw xposFraction moveSpeed
	bcc doNotAddHighest	
	inc xpos+1
doNotAddHighest
	jmp notpressed
pressedDown
	lda ypos+1
	cmp #3 ;do not fall when a block is at the top of the screen
	bcc notpressed
	
	lda fallFlag
	beq stopFalling
	
	lda #0 ;zero triggers quick fall
	;sta fallFlag
	rts

stopFalling
notpressed
	lda #1
	rts
fallFlag .by 0 ; 0 - was falling so it should stop. 1 - was not falling, so it should fall
.endl
;--------------------------------------------------
getkey .local ; waits for pressing a key and returns pressed value in A
;--------------------------------------------------
;keyboard reading
; KBCODE keeps code of last keybi
; SKSTAT  $ff - nothing pressed
;  $FB - any key
;  $f7 - shift
;  $f3 - shift+key

    pause 5
    lda SKSTAT
    cmp #$ff
    beq noWait
    cmp #$f7
    bne getkey ; I guess it waits for RELEASING a key
	lda JSTICK0
	and #$0f
	cmp #$0f
	bne getkey ; waits for not moving the joy
	lda TRIG0
	beq getkey ; waits for releasing FIRE
;-----------------sans waiting-------------
noWait
	lda SKSTAT
    cmp #$ff
    beq checkJoyGetKey ; key not pressed, check Joy
    cmp #$f7
    beq checkJoyGetKey ; key not pressed, check Joy

    lda kbcode
    and #$3f ;CTRL and SHIFT ellimination
    rts
checkJoyGetKey
    ;------------JOY-------------
    ;happy happy joy joy
    ;check for joystick now
    lda JSTICK0
    ;and JSTICK1 ;messing around with two sticks
    and #$0f
    cmp #$0f
    beq notpressedJoy
    tay 
    lda joyToKeyTable,y
    rts
notpressedJoy
    ;fire

    ;-commented out as- fire is checked to slow movements somewhere else
    lda TRIG0
    bne noFire
    lda #$0c ;Return key
	rts
noFire
	lda CONSOL
	and #%00000001
	bne noCONSOL
	lda #$0c ;Return key
	rts

noCONSOL
    lda #$ff
    rts

joyToKeyTable
    .by $ff,$ff,$ff,$ff,$ff,$ff,$ff,$07,$ff,$ff,$ff,$06,$ff,$0f,$0e,$ff
 .endl
;--------------------------------------------------
GetKeyDepress .local
;--------------------------------------------------
	lda depressFlag
	bne wasDepressed ;like me
;wasNotDepressed
	jsr getkey.noWait
	cmp #$ff
	bne pressed
	ldx #1
	stx depressFlag
pressed
	lda #$ff ;return with depression
	rts 
wasDepressed
	jsr getkey.noWait
	bmi notPressed
	ldx #0
	stx depressFlag
notPressed
	rts
.endl
depressFlag	.by 0 ;1 when was depressed at some point
;--------------------------------------------------
ShapeToBuffer .local
;--------------------------------------------------
;x, y - position
;currShape, currRot - shape and its rotation
	lda #0
	:maxShapeH sta shapeBuffer+2*#+1
	
	;move shape to the buffer
	mwa #shapeFont+512 addr1 ;beginning of the shapes - half the font
	;mwa #shapeFont+30 	 addr1 
	;offset = currShape*4*8 + currRot*8 (byte - max 7+1 shapes, 4 rots !!!)
	lda currShape
	:5 asl
	sta addr2
	lda currRot+1
	:3 asl 
	adc addr2
	tay
	ldx #0
loop03
	lda (addr1),y
	sta shapeBuffer,x
	iny
	inx
	inx
	cpx #maxShapeH*2
	bne loop03
	; current shape is in shapeBuffer now
	; shift the shape to the pixel position (right)
	lda xpos
	and #%00000111
	tax
	beq doNotShiftBuffer
loop04
	.REPT maxShapeH, #*2
		lsr shapeBuffer+:1
		ror shapeBuffer+:1+1
	.ENDR
	dex
	bne loop04
	;shapeBuffer shifted
doNotShiftBuffer
	rts
.endl

;--------------------------------------------------
BufferEraseScreen .local
;--------------------------------------------------
	jsr yposToAddr
	jsr xposToAddr

	;--put on screen now

	ldx #0  
	ldy addr2
loop05
	lda shapeBuffer,x
	eor #$FF
	and (addr1),y	
	sta (addr1),y
	iny
	inx
	lda shapeBuffer,x
	eor #$FF
	and (addr1),y
	sta (addr1),y
	dey
	adw addr1 #screenBytes
	inx
	cpx #maxShapeH*2
	bne loop05
	rts
.endl

;--------------------------------------------------
BufferToScreen .local
;--------------------------------------------------
	jsr yposToAddr
	jsr xposToAddr

	;--put on screen now

	ldx #0  
	ldy addr2
loop05
	lda (addr1),y
	ora shapeBuffer,x
	sta (addr1),y
	iny
	inx
	lda (addr1),y
	ora shapeBuffer,x
	sta (addr1),y
	dey
	adw addr1 #screenBytes
	inx
	cpx #maxShapeH*2
	bne loop05
	rts
.endl
;--------------------------------------------------
yposToAddr .local ;yposition to address offset in (addr1)
;--------------------------------------------------
	ldx ypos+1
	lda lineAddrL,x
	sta addr1
	lda lineAddrH,x
	sta addr1+1
	rts
	
	;slow and short version below...
	;y address (ypos * 40 + display)
	;y*40 = y*(32+8) = 8y + 32y
/*
	mva #0 addr1+1
	lda ypos+1
	sta addr1
	ldx #3
loop01	
	aslw addr1
	dex 
	bne loop01 ;addr1 *8
	mwa addr1 addr2 ;store y*8
	ldx #2
loop02	
	aslw addr1
	dex 
	bne loop02 ;addr1 *32
	adw addr1 addr2 ; y*8 + y+32
	adw addr1 #logicalDisplay ;addr1 = display + ypos*40
    ;here I have screen line address in (addr1) .word
	rts
*/
lineAddrL
	:screenHeight+maxShapeH+1 .by <(display+#*40)
lineAddrH
	:screenHeight+maxShapeH+1 .by >(display+#*40)

.endl
;--------------------------------------------------
xposToAddr .local
;--------------------------------------------------
	mwa xpos addr2
	:3 lsrw addr2
    ;here I have screen byte offset in addr2 .byte
	rts
.endl


;--------------------------------------------------
getSizeXY .local ;gets X size of current shape and rotation in A, Y size in Y
;--------------------------------------------------
	;sizeX = shapes+(currshape*8 + currRot*2)
	lda currShape
	:3 asl
	sta addr1
	lda currRot+1
	asl
	clc
	adc addr1
	tax
	lda shapes+1,x ;Y size
	tay
	lda shapes,x ;X size
	rts
.endl

;--------------------------------------------------
CheckPlacement .local ;check if possible to put shape in the given position - A=0 == YES
;--------------------------------------------------
	;first of all check if it is not end of the screen
	;if (sizeY+ypos > screenHeight) then stop
	jsr getSizeXY
	tya
	clc
	adc ypos+1
	cmp #screenHeight+1 
	bcc notBottom
	lda #$ff
	rts ;A!=0 here
notBottom
	;check if sum of pixels in buffer and on screen equals 
    ;number of pixels when the shape is placed.


	;before detailed check test ypos+1 to be higher than lowestY
	lda ypos+1
	clc
	adc #maxShapeH
	cmp lowestY
	bcs check
	lda #0
	rts
check

	;move screen area to save buffer
	jsr yposToAddr
	jsr xposToAddr 	

	;--move screen to buffer

	ldx #0  
	ldy addr2
loop05
	lda (addr1),y
	and shapeBuffer,x
	sta saveBuffer,x	
	iny
	inx
	lda (addr1),y
	and shapeBuffer,x
	sta saveBuffer,x
	dey
	adw addr1 #screenBytes
	inx
	cpx #maxShapeH*2
	bne loop05
/*	
0 = .
1 = #

shb
#.
#.
..

sb
..
##
##

shb AND sb
..
#.
..
if not 0 then apparently a collision
*/
	;iterate ofer saveBuffer - if not zeros, then there is a collision
		
	ldx #0  
	txa
loop06
	ora saveBuffer,x	
	inx
	cpx #maxShapeH*2
	bne loop06
	tax
	rts
.endl

;--------------------------------------------------
EraseFullLines .local ;erase full lines starting from ypos to ypos+maxShapeH
; returns in A number of deleted lines
;--------------------------------------------------
	jsr yposToAddr
	mva #0 deletedLines
	mva #0 counter
outerCheckLoop
	ldy #(screenWidth/8)-1 ;was screenBytes-1
	lda #$ff
loop
	and (addr1),y
	dey
	bpl loop
	cmp #$ff
	jne doNotEraseLine

eraseLine
	mva #3 sfx_effect
	
	;blink the erased line as requested by TDC

	ldx #0
waitForTheLine
	lda ypos+1
	clc
	adc counter
	tay ;temp save
	lsr

	clc
	adc #12 ;offset
	cmp vcount
	bne waitForTheLine

	lda BlinkTable,x
	sta WSYNC
	sta COLPF1
	;sta colbak
	sta WSYNC
	mva COLPF1S COLPF1
	;mva COLBAKS COLBAK

	inx
	cpx #blinkTableEnd-blinkTable
	bne waitForTheLine
	
	
	;move down screen contents, that is screenBytes (40) bytes down
	mwa addr1 addr2
	mwa addr1 temp

	ldx ypos+1
outerLoop
	sbw addr2 #screenBytes
	ldy #screenBytes-1
loopErase
	lda (addr2),y
	sta (temp),y
	dey
	bpl loopErase
	sbw temp #screenBytes
	dex
	bne outerLoop
	inc lowestY ;lowest Y is now going down (that is, incremented)
	inc deletedLines


doNotEraseLine
	adw addr1 #screenBytes
	inc:lda counter
	cmp #maxShapeH-1
	jne outerCheckLoop
	lda deletedLines	
	rts

deletedLines .by 0
BlinkTable	.by $c,$e,$c,$a,8,6,4,2,0,0,0
BlinkTableEnd
.endl


;--------------------------------------------------
clearscreen .local
;--------------------------------------------------
    lda #0
    tax
loop06
    :31 sta logicalDisplay+$100*#,x
    inx
    bne loop06
    rts
.endl
 
;--------------------------------------------------
smearscreen .local
;--------------------------------------------------
 
 	lda #150
 	sta lowestY
 	sta ypos+1
 	jsr yposToAddr
 	ldy #0
 
loop06
	lda random
	:4 ora random
	sta (addr1),y
	adw addr1 #1
	cpw addr1 #(display+screenHeight*screenBytes+screenBytes)
    bne loop06
    rts
.endl

spriteBackground .local
/*
1 POKE 106,PEEK(106)-4:GRAPHICS 0:PMB=PEEK(106):FOR I=PMB*256+384 TO PMB*256+1024:POKE I,170:NEXT I
2 POKE 54279,PMB
3 POKE 623,1+16:POKE 53277,3:POKE 53256,3:POKE 53257,3:POKE 53258,3:POKE 53259,3:POKE 53248,112:POKE 53260,255
4 POKE 53249,48:POKE 53250,80:POKE 53251,144:POKE 53255,176:POKE 53254,184:POKE 53253,192:POKE 53252,200
5 POKE 559,46:POKE 704,8:POKE 706,6:POKE 707,10:POKE 705,4:POKE 711,12:POKE 710,0:POKE 709,15

Interesujcy sposb wykorzystania grafiki P/M pokazuje program Pawa Kalinowskiego z Putuska. 
Rwnie ciekawy, a moe nawet ciekawszy efekt mona uzyska, wpisujc w wierszu 2 liczb 224 lub 204 zamiast PMB.
*/
	;checkered background
	ldx #3*4
	ldy #4
	lda #%01010101
loop
	sta PMG+$180,x
	sta PMG+$200,x
	sta PMG+$280,x
	sta PMG+$300,x
	sta PMG+$380,x
	dey
	bne doNotSwitch
	eor #$ff
	ldy #4
doNotSwitch
	inx
	cpx #3*4+24*4
	bne loop
	;lame.... soooo lameeeeee.... :]
	mva #>PMG 54279
	;mva #224 54279
 	mva #1+16 623
 	mva #3 53277
 	mva #3 53256
	mva #3 53257
	mva #3 53258
	mva #3 53259
	mva #255 53260
/*
	mva #112 hposp0
	mva #48 hposp1
	mva #80 hposp2
	mva #144 hposp3
	mva #176 hposm3
	mva #184 hposm2
	mva #192 hposm1
	mva #200 hposm0
*/
	mva #48 hposm3
	mva #48+8 hposm2
	mva #48+8*2 hposm1
	mva #48+8*3 hposm0
	mva #80 hposp0
	mva #112 hposp1
	mva #144 hposp2
	mva #176 hposp3

	mva #46 559
	mva #$96 704
	mva #$96 706
	mva #$96 707
	mva #$96 705
	mva #$96 711
	;mva #0 710
	;mva #15 709
	 
 
 	rts
.endl

;--------------------------------------------------
displaydec .local ;decimal (3 bytes), 6 digits
;--------------------------------------------------
; displays decimal number (in text mode) to decimalResultLong
; leading zeroes are removed -- not
; the range is three bytes (0 -- 16 777 216, but 999 999 is max here)

    ldy #5  ; there will be 6 digits
NextDigit
    ldx #24 ; 24-bit dividee so Rotate 24 times
    lda #$00
Rotate000
    ASL decimal
    ROL decimal+1
    ROL decimal+2
    rol  ; scroll dividee
    ; (as highest byte - additional - byte is A)
    cmp #10  ; divider
    bcc TooLittle000 ; if A is smaller than divider
    ; there is nothing to substract
    sbc #10  ; divider
    inc decimal     ; lowest bit set to 1
    ; because it is 0 and this is the fastest way
TooLittle000 dex
    bne Rotate000 ; and Rotate 24 times, Result will be in decimal
    tax  ; and the rest in A
    ; (and it goes to X because
    ; it is our decimal digit)
    lda digits,x
    sta decimalresultLong,y
    dey
    bpl NextDigit ; Result again /10 and we have next digit

/*
rightnumber
; now cut leading zeroes (002 goes   2)
    lda decimalresult
    cmp zero
    bne decimalend
    lda space
    sta decimalresult

    lda decimalresult+1
    cmp zero
    bne decimalend
    lda space
    sta decimalresult+1

    lda decimalresult+2
    cmp zero
    bne DecimalEnd
    lda space
    sta decimalresult+2
*/
DecimalEnd
/*
    ; displaying
    mwa displayposition temp
    ldy #6-1
displayloop
    lda decimalresult,y
    sta (temp),y
    dey
    bpl displayloop
*/
    rts
;--------------------------------------------------
displaybyte ;decimal (byte), displayposition  (word)
;--------------------------------------------------
; displays decimal number as in parameters (in text mode)
; leading zeroes are removed
; the range is (00..99 - one byte)

    ldy #1 ; there will be 2 digits
NextDigit2
    ldx #8 ; 8-bit dividee so Rotate 8 times
    lda #$00
Rotate001
    asl decimal
    rol  ; scroll dividee
    ; (as highest byte - additional - byte is A)
    cmp #10  ; divider
    bcc TooLittle001 ; if A is smaller than divider
    ; there is nothing to substract
    sbc #10  ; divider
    inc decimal     ; because it is 0 and this is the fastest way
TooLittle001 dex
    bne Rotate001 ; and Rotate 8 times, Result will be in decimal
    tax  ; and the rest in A
    ; (and it goes to X because
    ; it is our decimal digit)
    lda digits,x
    sta decimalresult,y
    dey
    bpl NextDigit2 ; Result again /10 and we have next digit

; now cut leading zeroes (02 goes   2)
    lda decimalresult
    cmp zero
    bne decimalend1
    lda space
    sta decimalresult

decimalend1
    rts
;-------decimal constans
zero
digits   dta d"0123456789"
    dta d"9"+1
space    dta d" "
;displaydecimal
.endl

;---------------------------------------------------
updateLowestY .local
;---------------------------------------------------
	lda ypos+1
	cmp lowestY
	bcs noChangeY 
	sta lowestY
noChangeY
	rts
.endl
;---------------------------------------------------
;---------------------------------------------------
UpdateScore .local
;in A - number of deleted lines (0-4)
;---------------------------------------------------
	beq doNotUpdate
	tax
	lda scoreUpdateTab,x ;in fact it adds score * 2
	jsr AddToScore
	lda scoreUpdateTab,x
	jsr AddToScore 
	lda scoreUpdateTab,x
	jsr AddToScore 
doNotUpdate
	rts
scoreUpdateTab .by 0,40,100,160,250 
.endl
;---------------------------------------------------
AddToScore .local
;in A - what to add to the score
;---------------------------------------------------
	clc
	adc score
	sta score
	bcc addend
	inc score+1
	bne addend
	inc score+2
	bne addend
	inc score+3
addend	
	rts
.endl
;---------------------------------------------------
printToSprites .local 
;
;---------------------------------------------------
;screencode("0") = 16
;system font = 224
;	sta PMG+$180,x
;	sta PMG+$200,x
	offset = PMG+$180+20
	charset = $E0 ;($E000 - std ROM charset)
	
	mwa #offset temp
	mva #0 prCounter
	sta leading
mainloop
	ldx prCounter
	lda decimalResultLong,x
	sec
	sbc #"0"
	ora:sta leading ;skip leading zeroes
	beq skipdigit

	lda decimalResultLong,x
	;clc
	;adc #"0"
	:3 asl 
	tax
	ldy #0
loop2
	lda charset*256,x

	iny
	sta (temp),y ;PMG+?offset+1,x 
	iny
	iny
	sta (temp),y ;PMG+?offset+3,x 
	iny
	inx
	cpy #8*4
	bne loop2
skipdigit
	adw temp #$80 ;skip to the next sprite
 	inc:lda prCounter
 	cmp #5
 	bne mainloop

	rts
leading .by 0
.endl
;---------------------------------------------------
printToSpritesScroll .local 
;---------------------------------------------------
;screencode("0") = 16
;system font = 224
;	sta PMG+$180,x
;	sta PMG+$200,x
	offset = PMG+$180+20+8*4+4
	charset = $E0 ;($E000 - std ROM charset)
	
	mwa #offset temp
	mva #0 prCounter
mainloop
	ldx prCounter
	lda scrollBuffer,x
	sta addr1
	mva #0 addr1+1
	:3 aslw addr1 ;*8
	adb addr1+1 #charset
	ldy #0
	sty ycount
loop2
	sty ytemp
	ldy ycount
	lda (addr1),y
	inc ycount
	ldy ytemp

	iny
	sta (temp),y ;PMG+?offset+1,x 
	iny
	iny
	sta (temp),y ;PMG+?offset+3,x 
	iny
	cpy #8*4
	bne loop2

	adw temp #$80 ;skip to the next sprite
 	inc:lda prCounter
 	cmp #5
 	bne mainloop

	rts
ytemp .by 0
ycount .by 0
.endl

;---------------------------------------------------
GameOverScroll .local
;---------------------------------------------------
	mwa #gameOverText addr2
	mva #0 depressFlag
	
	;move txt to buffer
scrolly
	ldy #0
moveit
	lda (addr2),y
	sta scrollBuffer,y
	iny
	cpy #5
	bne moveit
	jsr PrintToSpritesScroll
	pause 10


	;jsr getkey.noWait
	jsr GetKeyDepress
	cmp #$0c
	beq scrollEnd
	adw addr2 #1
	cpw addr2 #gameOverTextEnd
	bne scrolly
	mwa #gameOverText addr2
	jmp scrolly
	
scrollEnd
	rts
	
.endl
.endif