
    icl 'lib/atari.hea'
    icl 'lib/macro.hea'

screenWidth = 320 ;logical screen in pixels
screenHeight = 192 ;192
screenBytes = 40  ;physical screen in bytes (32/40/48)
maxShapeH = 4 ; maximum shape height
normalMoveSpeed = $30 ;($0.30)
display = $9000+$10
PMG = $B800 ; just before the ROM, NO BASIC!!!
logicalDisplay = display-maxShapeH*screenBytes
   .zpvar xposFraction .byte = $80+$20 ;fractional part of xpos, +$20 for RMT
   .zpvar xpos, ypos, addr1, addr2 .word ; position of the shape
   .zpvar currShape, lowestY .byte
   .zpvar drawAddr, moveSpeed .word
   .zpvar temp .word ;most nested loops only
   

   
    org $1000
;---------------------------------------------------
	icl 'subroutines.asm'
;---------------------------------------------------
start
	jsr CheckPALorNTSC
restart
	jsr IntroScreen
	jsr GameInit 
newBlock
	mwa #screenWidth/2 xpos
	mwa #0 ypos
	jsr RandomizeShape
loopx
	mva #1 ReadControls.fallFlag
	jsr SavePos
	jsr ReadControls
	jeq FreeFall
	jsr ShapeToBuffer
	jsr CheckPlacement ;check if can draw shape
	beq canMove
	jsr RetrievePos; revert old positions
		
canMove
	jsr SavePos
	adw ypos fallSpeed
	jsr ShapeToBuffer
	jsr CheckPlacement ;check if can draw shape
	jne EndOfFall
	jsr BufferToScreen
	jsr PrintTimes
	jsr WaitForIt
    jsr BufferEraseScreen
	jmp loopx

EndOfFall
	lda ypos+1
	cmp #maxShapeH
	jcc GameOver
EndOfFreeFall
	mva #2 sfx_effect
	lda #1
	jsr AddToScore
	jsr updateLowestY
	jsr RetrievePos
	jsr ShapeToBuffer
	jsr BufferToScreen
	jsr EraseFullLines
	jsr UpdateScore
	:3 mva score+# decimal+#
	jsr displaydec
	lda #0
	jsr printToSprites
	jmp newBlock
;------------------------------
GameOver
	mva #1 slowMusic
    ldx #<MODUL					;low byte of RMT module to X reg
    ldy #>MODUL					;hi byte of RMT module to Y reg
	lda #7						;starting song line 0-255 to A reg
	jsr RASTERMUSICTRACKER		;Init
	jsr GameOverScroll
	mva #0 slowMusic
	jmp restart 
;------------------------------
FreeFall .local
	mva #1 sfx_effect
	mva #0 ReadControls.fallFlag
	;mva #0 depressFlag
canMove
	jsr SavePos
	adw ypos #$100 ;freefallSpeed
	;jsr ShapeToBuffer
	jsr CheckPlacement ;check if can draw shape
	jne EndOfFreeFall
	jsr BufferToScreen
	jsr PrintTimes	;works as a delay as well
	jsr WaitForIt
	jsr BufferEraseScreen

	jsr getKeyDepress
	cmp #$ff
	jne loopx

	jmp canMove
.endl
;------------------------------

IntroScreen
    ldx #<MODUL					;low byte of RMT module to X reg
    ldy #>MODUL					;hi byte of RMT module to Y reg
	lda #7						;starting song line 0-255 to A reg
	jsr RASTERMUSICTRACKER		;Init

	mva #0 depressFlag
	jsr main_ged

/*
	jsr getKey.noWait
	cmp #$0c
	beq quitIntro
	cmp #33 ;space
	beq quitIntro
	jmp lolop
quitIntro
*/
	rts



;--------global, non-zpage variables-------
ticksPerSecond .by 0 ;do not clear me :]

clearVariablesStart
shapeBuffer
	:maxShapeH .by 0,0
saveBuffer
	:maxShapeH .by 0,0
xposOld .wo 0
yposOld	.wo 0
fallSpeed	.wo 0
currRot	.wo 0
counter .by 0
days	.by 0
hours	.by 0
minutes	.by 0
seconds	.by 0
ticks	.by 0
score	.wo 0,0
sfx_effect .by 0

prCounter .by 0
scrollBuffer :6 dta d" "
decimal  .by 0,0,0
decimalResultLong dta d"0000" ;+two bytes below
decimalresult  dta d"00"
displayposition .wo 0
slowMusic .by 0

clearVariablesEnd


	icl 'data.asm'
endOfTheCode
	.IF endOfTheCode>$1fff
		.ERROR "shift code, dude"
	.ENDIF
	ORG $2000
MODUL
	ins 'artwork/stripped_v2.rmt',+6
	.align $100
	icl 'rmtplayr.a65'


	.align $400
	icl 'artwork/old_man_intro/old_man_intro.h'
	.ds $10 ;to be removed if not important for GED
	icl 'artwork/old_man_intro/old_man_intro.asq'
gameOverText 
	dta d"     Game Over... Code: pirx... Sound: Miker... Testing: TDC... Thank you for playing Tetryx, the game for old men. "
	dta d"Tools used: MADS, WUDSN, Altirra, RMT, Rastaconverter, Exomizer. Thanx fly to TeBe, JAC!, phaeron, Raster, Ilmenit, Magnus Lind, "
	dta d"Alexey Pajitnov and the whole Atari and 65xx community out there. May the power without the price be with you!"
gameOverTextEnd dta d"      "

endOfData
	.IF endOfData>display
		.ERROR "shift data, dude"
	.ENDIF

	
	run start
	
